use std::env;
use std::process::Command;

static mut ZERO: usize = 0;

fn diff<T: PartialEq + Clone>(x: &[T], y: &[T]) -> Vec<T> {
    let mut table: Vec<usize> = vec![0; x.len() * y.len()]; 
    let mut table_value = |i: usize, j: usize| unsafe {
        if i == usize::MAX || j == usize::MAX {
            &mut ZERO
        } else {
            &mut *(&mut table[j + i*y.len()] as *mut usize)
        }
    };

    for (j, b) in y.iter().enumerate() {
        for (i, a) in x.iter().enumerate() {
            *table_value(i, j) = if a == b {
                *table_value(i-1, j-1) + 1
            } else {
                *table_value(i-1, j).max(table_value(i, j-1))
            };
        }
    }

    let mut r = Vec::new();
    let mut i = x.len() - 1;
    let mut j = y.len() - 1;
    while i != usize::MAX && j != usize::MAX {
        if x[i] == y[j] {
            r.push(x[i].clone());
            i -= 1;
            j -= 1;
        } else if table_value(i, j-1) > table_value(i-1, j) {
            j -= 1;
        } else {
            i -= 1;
        }
    }

    r.reverse();
    r
}

pub fn lis(x: &[u32]) -> Vec<u32> {
    let mut v = x.to_owned();
    v.sort();
    v.dedup();
    diff(x, &v)
}

fn main() -> std::io::Result<()> {
    if cfg!(debug_assertions) {
        // shit.
        Command::new("rustc")
            .arg("-O")
            .arg(file!())
            .spawn()?
            .wait()?;
        Command::new("./ans")
            .args(env::args_os().skip(1))
            .spawn()?
            .wait()?;
        return Ok(());
    }

    let input: Vec<u32> = env::args().skip(1).map(|x| x.parse().unwrap()).collect();
    println!("{:?}", lis(&input));
    Ok(())
}
